package rest;

import java.io.IOException;
import java.util.*;


import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;

/**
 * Implements a simple RESTful service.
 */
 public class CatalogServlet extends javax.servlet.http.HttpServlet 
     implements javax.servlet.Servlet {
  
    private Catalog catalog;

    public CatalogServlet() {
        super();
	catalog = new Catalog();
    } 

    protected void doGet(HttpServletRequest request, HttpServletResponse response) 
        throws ServletException, IOException {

        System.out.println("DoGet invoked on RESTful service.");
        Source xmlSource = asXml(catalog);

        ServletOutputStream out = response.getOutputStream();
        response.setContentType("text/xml");

        StreamResult st = new StreamResult(out);

	// The transformer writes to the output stream
        try {
            Transformer t = 
                 TransformerFactory.newInstance().newTransformer();
            t.transform(xmlSource, st);
        } catch (Exception e) {
            throw new ServletException(e);
        }
    } // doGet

     /* 
      * Hides the JAXB part of marshalling the catalog into XML 
      */

        private static Source asXml(Catalog pc) throws ServletException {
            System.out.println("Marshalling...");

            Source source = null;
            Document doc = null;

            try {
		// the Catalog is the root, it is then the context
                JAXBContext ctx = JAXBContext.newInstance(Catalog.class);
                Marshaller m = ctx.createMarshaller();

                DocumentBuilder parser = 
                DocumentBuilderFactory.newInstance().newDocumentBuilder();
                doc = parser.newDocument();
                m.marshal(pc, doc);

            } catch (JAXBException je) {
                throw new ServletException(je);
            } catch (ParserConfigurationException pce) {
                throw new ServletException(pce);
            }
            source = new DOMSource(doc);

            return source;
	} // asXml

     
        protected void doPost(HttpServletRequest request, HttpServletResponse response) 
            throws ServletException, IOException {	    
	    
	    doGet(request, response);
	}
}
